diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index d88ca6e70..07e1ebc04 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -4,43 +4,53 @@ import net.betterthanadventure.utils.BiomeFinder;
 import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiControllerSetup;
-import net.minecraft.client.gui.GuiException;
 import net.minecraft.client.gui.GuiHudDesigner;
-import net.minecraft.client.gui.GuiMainMenu;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
-import net.minecraft.client.gui.guidebook.PageManager;
-import net.minecraft.client.gui.guidebook.search.SearchPage;
+import net.minecraft.client.gui.GuiSoundTest;
+import net.minecraft.client.gui.GuiTextureViewer;
+import net.minecraft.client.gui.achievements.GuiAchievements;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.options.components.*;
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.options.components.AvailableTexturePackListComponent;
+import net.minecraft.client.gui.options.components.BooleanOptionComponent;
+import net.minecraft.client.gui.options.components.FloatOptionComponent;
+import net.minecraft.client.gui.options.components.FramerateOptionComponent;
+import net.minecraft.client.gui.options.components.IntegerOptionComponent;
+import net.minecraft.client.gui.options.components.KeyBindingComponent;
+import net.minecraft.client.gui.options.components.LanguagePackListComponent;
+import net.minecraft.client.gui.options.components.OptionsCategory;
+import net.minecraft.client.gui.options.components.SearchFieldComponent;
+import net.minecraft.client.gui.options.components.SelectedTexturePackListComponent;
+import net.minecraft.client.gui.options.components.ShortcutComponent;
+import net.minecraft.client.gui.options.components.ToggleableOptionComponent;
+import net.minecraft.client.gui.options.components.TooltipPickerComponent;
 import net.minecraft.client.player.controller.PlayerControllerSP;
-import net.minecraft.client.render.OpenGLHelper;
+import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.core.Global;
+import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.data.registry.recipe.SearchQuery;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.World;
-import org.lwjgl.opengl.GL11;
 
+import javax.management.RuntimeErrorException;
 import java.io.File;
 
 
 public abstract class OptionsPages
 {
     private static final Minecraft mc = Minecraft.getMinecraft(OptionsPages.class);
-    public static final OptionsPage GENERAL = register(new OptionsPage("gui.options.page.general.title", new ItemStack(Block.grassRetro))
+    public static final OptionsPage GENERAL = register(new OptionsPage("gui.options.page.general.title", new ItemStack(Blocks.GRASS_RETRO))
         .withComponent(new OptionsCategory("gui.options.page.general.category.gameplay")
             .withComponent(new FloatOptionComponent(mc.gameSettings.FoV))
             .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.difficulty))
             .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.placementMode))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.autoHit))
+            .withComponent(new BooleanOptionComponent(mc.gameSettings.easyBridge))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.viewBobbing))
         )
         .withComponent(new OptionsCategory("gui.options.page.general.category.user_interface")
+            .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayGuiScreen(new GuiHudDesigner(mc.currentScreen))))
             .withComponent(new IntegerOptionComponent(mc.gameSettings.guiScale))
             .withComponent(new FloatOptionComponent(mc.gameSettings.screenPadding))
             .withComponent(new TooltipPickerComponent<>(mc.gameSettings.tooltipStyle))
@@ -59,7 +69,6 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.forceUnicodeFont))
             .withComponent(new FloatOptionComponent(mc.gameSettings.autosaveTimer))
         )
-        .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayGuiScreen(new GuiHudDesigner(mc.currentScreen))))
         .withComponent(new ShortcutComponent("gui.options.page.general.button.open_worlds_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "saves"))))
         .withComponent(new ShortcutComponent("gui.options.page.general.button.open_screenshots_folder", () -> {
             File f = new File(mc.getMinecraftDir(), "screenshots");
@@ -68,7 +77,7 @@ public abstract class OptionsPages
         }))
     );
 
-    public static final OptionsPage AUDIO = register(new OptionsPage("gui.options.page.audio.title", new ItemStack(Item.recordCat))
+    public static final OptionsPage AUDIO = register(new OptionsPage("gui.options.page.audio.title", new ItemStack(Items.RECORD_CAT))
         .withComponent(new OptionsCategory("gui.options.page.audio.category.audio")
             .withComponent(new BooleanOptionComponent(mc.gameSettings.muteOnLostFocus))
             .withComponent(new FloatOptionComponent(mc.gameSettings.masterVolume))
@@ -80,7 +89,7 @@ public abstract class OptionsPages
             .withComponent(new FloatOptionComponent(mc.gameSettings.guiSoundsVolume))
         )
     );
-    public static final OptionsPage VIDEO = register(new OptionsPage("gui.options.page.video.title", new ItemStack(Item.flag))
+    public static final OptionsPage VIDEO = register(new OptionsPage("gui.options.page.video.title", new ItemStack(Items.FLAG))
         .withComponent(new OptionsCategory("gui.options.page.video.category.graphics")
             .withComponent(new BooleanOptionComponent(mc.gameSettings.fullscreen))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.borderlessFullscreen))
@@ -119,8 +128,7 @@ public abstract class OptionsPages
             .withComponent(new FloatOptionComponent(mc.gameSettings.blockOutlineWidth))
         )
     );
-    public static final OptionsPage CONTROLS = register(new OptionsPage("gui.options.page.controls.title", new ItemStack(Item.boat))
-        .withComponent(new ShortcutComponent("gui.options.page.controls.button.controller_setup", () -> mc.displayGuiScreen(new GuiControllerSetup(mc.currentScreen))))
+    public static final OptionsPage CONTROLS = register(new OptionsPage("gui.options.page.controls.title", new ItemStack(Items.BOAT))
         .withComponent(new OptionsCategory("gui.options.page.controls.category.mouse")
             .withComponent(new FloatOptionComponent(mc.gameSettings.mouseSensitivity))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.invertMouse))
@@ -135,6 +143,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.swapCraftingButtons))
         )
         .withComponent(new OptionsCategory("gui.options.page.controls.category.controller")
+            .withComponent(new ShortcutComponent("gui.options.page.controls.button.controller_setup", () -> mc.displayGuiScreen(new GuiControllerSetup(mc.currentScreen))))
             .withComponent(new FloatOptionComponent(mc.gameSettings.controllerSensitivity))
             .withComponent(new FloatOptionComponent(mc.gameSettings.controllerMenuSensitivity))
             .withComponent(new FloatOptionComponent(mc.gameSettings.controllerDeadzoneLeft))
@@ -205,7 +214,7 @@ public abstract class OptionsPages
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyScreenshot))
         )
     );
-    public static final OptionsPage TEXTURE_PACKS = register(new OptionsPage("gui.options.page.texture_packs.title", new ItemStack(Item.painting))
+    public static final OptionsPage TEXTURE_PACKS = register(new OptionsPage("gui.options.page.texture_packs.title", new ItemStack(Items.PAINTING))
         .withComponent(new ShortcutComponent("gui.options.page.texture_packs.button.open_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "texturepacks"))))
         .withComponent(new OptionsCategory("gui.options.page.texture_packs.category.textures")
             .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.animations))
@@ -221,16 +230,16 @@ public abstract class OptionsPages
             .withComponent(new AvailableTexturePackListComponent())
         )
     );
-    public static final OptionsPage LANGUAGE = register(new OptionsPage("gui.options.page.language_packs.title", new ItemStack(Item.book))
+    public static final OptionsPage LANGUAGE = register(new OptionsPage("gui.options.page.language_packs.title", new ItemStack(Items.BOOK))
         .withComponent(new ShortcutComponent("gui.options.page.language_packs.button.open_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "languages"))))
         .withComponent(new OptionsCategory("gui.options.page.language_packs.category.language_packs")
             .withComponent(new LanguagePackListComponent())
         )
     );
-    public static final OptionsPage SEARCH = register(new OptionsPage("gui.options.page.search.title", new ItemStack(Block.glass))
+    public static final OptionsPage SEARCH = register(new OptionsPage("gui.options.page.search.title", new ItemStack(Blocks.GLASS))
         .withComponent(new SearchFieldComponent())
     );
-    public static final OptionsPage DEBUG = new OptionsPage("gui.options.page.debug.title", Block.bedrock.getDefaultStack())
+    public static final OptionsPage DEBUG = new OptionsPage("gui.options.page.debug.title", Blocks.BEDROCK.getDefaultStack())
         .withComponent(new OptionsCategory("gui.options.page.debug.category.controls")
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleTextureAtlas))
             .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleDebug))
@@ -278,6 +287,8 @@ public abstract class OptionsPages
                                }
                            }
             )
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.sound_test", () -> mc.displayGuiScreen(new GuiSoundTest(mc.currentScreen))))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.texture_viewer", () -> mc.displayGuiScreen(new GuiTextureViewer(mc.currentScreen))))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.biome_finder", () -> {
                 BiomeFinder.main(new String[0]);
                 Global.accessor = mc;
@@ -287,18 +298,38 @@ public abstract class OptionsPages
                 Utils.openDirectory(new File(mc.getMinecraftDir(), "infodump"));
                 Global.accessor = mc;
             }))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.achievements", () -> mc.displayGuiScreen(new GuiAchievements(mc.currentScreen, mc.statsCounter))))
         )
         .withComponent(new OptionsCategory("gui.options.page.debug.category.test")
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.music.skip", () -> {
+                SoundEngine.getSoundSystem().stop("BgMusic");
+                mc.sndManager.ticksBeforeMusic = -1;
+                mc.sndManager.tick();
+            }))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.cheat", () -> {
+                mc.theWorld.getLevelData().setCheatsEnabled(true);
+            }) {
+                @Override
+                public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+                    button.enabled = (mc.theWorld != null && !mc.theWorld.isClientSide);
+                    super.render(x, y, width, relativeMouseX, relativeMouseY);
+                }
+            })
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.wipestats", () -> {
+                mc.statsCounter.wipe("I want to delete all the saved stats");
+            }))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.unlockedall", () -> {
+                for (Stat stat : StatList.getAllStats()){
+                    mc.thePlayer.addStat(stat, mc.thePlayer.getStat(stat) == 0 ? 1 : 0);
+                }
+            }))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.crash.soft", () -> {
                 throw new RuntimeException("Test Soft Exception");
             }))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.crash.hard", () -> {
-                mc.changeWorld(null);
-                GuiPopup error = GuiException.createFatal(new RuntimeException("Test Hard Exception"), mc);
-                mc.displayGuiScreen(error);
+                throw new RuntimeErrorException(new Error(), "Test Hard Exception");
             }))
-        )
-            ;
+        );
 
     public static OptionsPage register(OptionsPage page)
     {
diff --git a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
index af5df7c22..8439fdd2f 100644
--- a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
+++ b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
@@ -177,16 +177,16 @@ public class GuiPaged
     {
         if (mouseX > leftWidth + SEPARATOR_WIDTH + PADDING && mouseX < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-                scrollRightPanel(Mouse.getDWheel() * -1.0f);
+                scrollRightPanel(Mouse.getDWheel() / -0.01f);
             } else {
-                scrollRightPanel(Mouse.getDWheel() / -5.0f);
+                scrollRightPanel(Mouse.getDWheel() / -0.05f);
             }
             onScrollRightPanel();
         } else if (mouseX >= 0 && mouseX <= leftWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-                scrollLeftPanel(Mouse.getDWheel() * -1.0f);
+                scrollLeftPanel(Mouse.getDWheel() / -0.01f);
             } else {
-                scrollLeftPanel(Mouse.getDWheel() / -5.0f);
+                scrollLeftPanel(Mouse.getDWheel() / -0.05f);
             }
             onScrollLeftPanel();
         }
@@ -427,7 +427,7 @@ public class GuiPaged
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -458,7 +458,7 @@ public class GuiPaged
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java b/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
index c0ef45899..8aa438cd8 100644
--- a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
+++ b/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
@@ -202,7 +202,7 @@ public final class GuiPopup
         GL11.glEnable(GL11.GL_TEXTURE_2D);
         float f = 32F;
         tessellator.startDrawingQuads();
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         tessellator.setColorOpaque_I(0x404040);
         tessellator.addVertexWithUV(popupX, popupY + popupHeight, 0.0D, 0.0D, (float)popupHeight / f);
         tessellator.addVertexWithUV(popupX + popupWidth, popupY + popupHeight, 0.0D, (float)popupWidth / f, (float)popupHeight / f);
diff --git a/src/main/java/net/minecraft/client/gui/popup/ListComponent.java b/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
index 76bed7d7a..4979e5fb8 100644
--- a/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
@@ -99,7 +99,7 @@ public class ListComponent
         {
             float wheel = Mouse.getDWheel();
             if (wheel != 0.0f)
-                scroll(wheel / -1200.0f);
+                scroll(wheel / -12.0f);
         }
 
         GL11.glDisable(GL11.GL_TEXTURE_2D);
diff --git a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index b2b4c7d43..0ad03e175 100644
--- a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -106,7 +106,7 @@ public class MessageBoxComponent
         {
             float wheel = Mouse.getDWheel();
             if (wheel != 0.0f)
-                scroll(wheel / -1200.0f);
+                scroll(wheel / -12.0f);
         }
 
         GL11.glDisable(GL11.GL_TEXTURE_2D);
diff --git a/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java b/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
new file mode 100644
index 000000000..ae5761f09
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
@@ -0,0 +1,98 @@
+package net.minecraft.client.gui.toasts;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class AchievementToast implements IToastable {
+    private static final double ANIMATION_DURATION_MILLIS = 3000L;
+    private long startTime;
+    private final Minecraft mc = Minecraft.getMinecraft(this);
+    private final Achievement achievement;
+    private final boolean informational;
+    public AchievementToast(Achievement achievement, boolean informational){
+        this.achievement = achievement;
+        this.informational = informational;
+    }
+    @Override
+    public boolean messageOnly(long runtime) {
+        return informational;
+    }
+
+    @Override
+    public String getTitle(long runtime) {
+        return I18n.getInstance().translateKey("gui.achievement.label.get");
+    }
+
+    @Override
+    public int nameColor(long runtime) {
+        return 0xffffff00;
+    }
+
+    @Override
+    public String getMessage(long runtime) {
+        return informational ? achievement.getDescription() : achievement.getStatName();
+    }
+
+    @Override
+    public int descriptionColor(long runtime) {
+        return 0xffffffff;
+    }
+
+    @Override
+    public double getAnimationProgress(long runtime) {
+        runtime = System.currentTimeMillis() - startTime;
+        double progress = runtime / ANIMATION_DURATION_MILLIS;
+        if (informational && !mc.statsCounter.isUnlocked(achievement)) {
+            progress = Math.min(progress, 0.5);
+            startTime = (long) (System.currentTimeMillis() - ANIMATION_DURATION_MILLIS/2);
+        }
+        return progress;
+    }
+
+    @Override
+    public String getTexture(long runtime) {
+        return "minecraft:gui/toast";
+    }
+
+    @Override
+    public void onToastStart() {
+        Random r = new Random();
+//        mc.sndManager.playSound("random.whoosh_in", SoundCategory.GUI_SOUNDS, 0.5f, 1f + (r.nextFloat() - r.nextFloat()) * 0.1f);
+        startTime = System.currentTimeMillis();
+        if (!informational) {
+            mc.sndManager.playSound("random.achievement", SoundCategory.GUI_SOUNDS, 1f, 1f);
+//            mc.sndManager.playSound("note.harp", SoundCategory.GUI_SOUNDS, 1f, 1f);
+//            mc.sndManager.playSound("note.snare", SoundCategory.GUI_SOUNDS, 1f, 0.9f);
+//            mc.sndManager.playSound("note.harp", SoundCategory.GUI_SOUNDS, 1f, 0.8f);
+        }
+    }
+
+    @Override
+    public void onToastEnd() {
+        Random r = new Random();
+//        mc.sndManager.playSound("random.whoosh_out", SoundCategory.GUI_SOUNDS, 0.5f, 1f + (r.nextFloat() - r.nextFloat()) * 0.1f);
+    }
+
+    @Override
+    public boolean isEquivalentToast(@NotNull IToastable toast) {
+        if (toast instanceof AchievementToast){
+            AchievementToast achievementToast = (AchievementToast) toast;
+            return (achievement == achievementToast.achievement) && (informational == ((AchievementToast) toast).informational);
+        }
+        return false;
+    }
+
+    @Override
+    public @Nullable ItemStack getIcon(long runtime) {
+        return Item.getItem(achievement.iconItemId).getDefaultStack();
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/gui/toasts/GuiHudToasts.java b/src/main/java/net/minecraft/client/gui/toasts/GuiHudToasts.java
new file mode 100644
index 000000000..497e3c57f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/toasts/GuiHudToasts.java
@@ -0,0 +1,195 @@
+package net.minecraft.client.gui.toasts;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.Global;
+import net.minecraft.client.render.Lighting;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+
+import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.List;
+
+public class GuiHudToasts extends Gui {
+    private static final int TOAST_WIDTH = 160;
+    private static final int TOAST_HEIGHT = 32;
+    private static final int MAX_SHOWN_ENTRIES = 5;
+
+    private final List<IToastable> overflowEntries = new ArrayList<>();
+    private final List<ToastEntry> activeEntries = new ArrayList<>();
+
+    private final Minecraft mc;
+
+    public GuiHudToasts(Minecraft minecraft) {
+        mc = minecraft;
+    }
+
+    public boolean isDisplayingToast(IToastable toast) {
+        for (ToastEntry entry : activeEntries){
+            if (entry.toast.isEquivalentToast(toast)){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public void addToast(IToastable toast) {
+        if (activeEntries.size() >= MAX_SHOWN_ENTRIES){
+            overflowEntries.add(toast);
+            return;
+        }
+        activeEntries.add(new ToastEntry(toast, System.currentTimeMillis()));
+        toast.onToastStart();
+        sortList();
+    }
+
+    public void endToast(IToastable toast){
+        for (int i = 0; i < activeEntries.size(); i++) {
+            ToastEntry entry = activeEntries.get(i);
+            if (entry.toast.isEquivalentToast(toast)){
+                activeEntries.remove(i);
+                entry.toast.onToastEnd();
+                sortList();
+                return;
+            }
+        }
+    }
+
+    protected void sortList(){
+        activeEntries.sort(ToastEntry.TOAST_SORTER);
+    }
+
+    private void updateScale() {
+        GL11.glViewport(0, 0, mc.resolution.width, mc.resolution.height);
+        GL11.glMatrixMode(GL11.GL_PROJECTION);
+        GL11.glLoadIdentity();
+        GL11.glMatrixMode(GL11.GL_MODELVIEW);
+        GL11.glLoadIdentity();
+        GL11.glClear(256);
+        GL11.glMatrixMode(GL11.GL_PROJECTION);
+        GL11.glLoadIdentity();
+        GL11.glOrtho(0.0D, mc.resolution.scaledWidth, mc.resolution.scaledHeight, 0.0D, 1000D, 3000D);
+        GL11.glMatrixMode(GL11.GL_MODELVIEW);
+        GL11.glLoadIdentity();
+        GL11.glTranslatef(0.0F, 0.0F, -2000F);
+    }
+
+    public void render(float partialTick)
+    {
+        if(Minecraft.hasPaidCheckTime > 0L) { // Puts unlicensed copy message at top left of screen
+            GL11.glDisable(GL11.GL_DEPTH_TEST);
+            GL11.glDepthMask(false);
+            Lighting.disable();
+            String s = I18n.getInstance().translateKeyAndFormat("gui.achievement.label.unlicensed.1", Global.VERSION);
+            String s1 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.2");
+            String s2 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.3");
+            mc.fontRenderer.drawStringWithShadow(s, 2, 2, 0xffffff);
+            mc.fontRenderer.drawStringWithShadow(s1, 2, 11, 0xffffff);
+            mc.fontRenderer.drawStringWithShadow(s2, 2, 20, 0xffffff);
+            GL11.glDepthMask(true);
+            GL11.glEnable(GL11.GL_DEPTH_TEST);
+        }
+
+        if (!overflowEntries.isEmpty()){
+            while (activeEntries.size() < MAX_SHOWN_ENTRIES && !overflowEntries.isEmpty()){
+                IToastable toast = overflowEntries.get(0);
+                overflowEntries.remove(0);
+                activeEntries.add(new ToastEntry(toast, System.currentTimeMillis() + 1));
+                toast.onToastStart();
+                sortList();
+            }
+        }
+
+        // Remove finished entries
+        List<ToastEntry> entriesCopy = new ArrayList<>(activeEntries);
+        for (ToastEntry entry : entriesCopy){
+            long duration = System.currentTimeMillis() - entry.startTime;
+            double animProgress = entry.toast.getAnimationProgress(duration);
+            if((animProgress < 0.0D || animProgress > 1.0D)) { // Finish animation
+                endToast(entry.toast);
+            }
+        }
+
+        if(activeEntries.isEmpty() || mc.thePlayer == null) {
+            return;
+        }
+        updateScale();
+
+
+        GL11.glDisable(GL11.GL_DEPTH_TEST);
+        GL11.glDepthMask(false);
+
+        int yOff = 0;
+        for (ToastEntry entry : activeEntries){ // Render all entries
+            long duration = System.currentTimeMillis() - entry.startTime;
+
+            double animProgress = entry.toast.getAnimationProgress(duration);
+            double hideAmount = animProgress * 2D; // when hideAmount == 0 the toast is fully on-screen | when hideAmount == 1 the toast is fully off-screen
+            if(hideAmount > 1.0D)
+            {
+                hideAmount = 2D - hideAmount;
+            }
+            hideAmount *= 4D;
+            hideAmount = 1.0D - hideAmount;
+            if(hideAmount < 0.0D)
+            {
+                hideAmount = 0.0D;
+            }
+            hideAmount *= hideAmount;
+            hideAmount *= hideAmount;
+            int toastLeft = mc.resolution.scaledWidth - TOAST_WIDTH;
+            int toastTop = (int) (-hideAmount * TOAST_HEIGHT);
+            if (toastTop < 0) {
+                Scissor.enable(toastLeft, yOff, TOAST_WIDTH, TOAST_HEIGHT);
+            }
+            renderToast(entry.toast, duration, toastLeft, toastTop + yOff);
+            Scissor.disable();
+            yOff += TOAST_HEIGHT + toastTop;
+        }
+
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        Lighting.disable();
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_DEPTH_TEST);
+    }
+    protected void renderToast(IToastable toast, long duration, int x, int y){
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GL11.glDisable(GL11.GL_LIGHTING);
+
+        drawGuiIcon(x, y, TOAST_WIDTH, TOAST_HEIGHT, TextureRegistry.getTexture(toast.getTexture(duration)));
+        if(toast.messageOnly(duration)) {
+            mc.fontRenderer.drawStringIntoConstrainedBlock(toast.getMessage(duration), x + 30, y + 7, 120, toast.descriptionColor(duration));
+        } else {
+            mc.fontRenderer.drawString(toast.getTitle(duration), x + 30, y + 7, toast.nameColor(duration));
+            mc.fontRenderer.drawString(toast.getMessage(duration), x + 30, y + 18, toast.descriptionColor(duration));
+        }
+
+        GL11.glDepthMask(true);
+        Lighting.enableInventoryLight();
+        GL11.glColor4f(1, 1, 1, 1);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+
+        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        ItemStack icon = toast.getIcon(duration);
+        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, icon, x + 8, y + 8, 1.0f);
+        GL11.glDisable(GL11.GL_DEPTH_TEST);
+    }
+
+    static class ToastEntry {
+        public static final Comparator<ToastEntry> TOAST_SORTER = (o1, o2) -> (int) (o1.startTime - o2.startTime);
+        public final long startTime;
+        public final IToastable toast;
+        public ToastEntry(IToastable toast, long startTime){
+            this.toast = toast;
+            this.startTime = startTime;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/toasts/IToastable.java b/src/main/java/net/minecraft/client/gui/toasts/IToastable.java
new file mode 100644
index 000000000..48ee651b1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/toasts/IToastable.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.gui.toasts;
+
+import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public interface IToastable {
+    boolean messageOnly(long runtime);
+
+    String getTitle(long runtime);
+
+    int nameColor(long runtime);
+
+    String getMessage(long runtime);
+
+    int descriptionColor(long runtime);
+
+    double getAnimationProgress(long runtime);
+
+    String getTexture(long runtime);
+
+    void onToastStart();
+    void onToastEnd();
+
+    boolean isEquivalentToast(@NotNull IToastable toast);
+
+    @Nullable
+    ItemStack getIcon(long runtime);
+}
